#ifndef id6FB3FC97331449038D42AAAB4C01ABA1
#define id6FB3FC97331449038D42AAAB4C01ABA1

#include "components/layer.hpp"
#include <vector>
#include <cassert>
#include <ciso646>
#include <memory>

namespace dk {
	template <size_t D>
	class Viewport;

	template <size_t D>
	class Tyler {
		typedef std::unique_ptr<LayerBase<D>> LayerPtr;
		typedef std::vector<LayerPtr> LayerList;
	public:
		typedef typename LayerBase<D>::coords coords;

		Tyler ( void ) = delete;
		explicit Tyler ( const coords& parSize );
		~Tyler ( void ) noexcept = default;

		typename coords::value_type tiles_count ( void ) const;
		const coords& map_size ( void ) const { return m_size; }
		template <typename T>
		size_t push_layer ( typename Layer<T, D>::streamer_type&& parStreamer );

	private:
		const coords m_size;
		LayerList m_layers;
	};
} //namespace dk

#include "implem/tyler.inl"

#endif
